function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.stickmode = 0; -- 0 is not stuck, 1 is stuck on object, 2 is stuck on terrain. DON'T EDIT THIS!

	self.lifeTimer = Timer();
	self.Sharpness = 255;

	if coalitionSGLtable == nil then
		coalitionSGLtable = {};
	end

	self.startMass = self.Mass;

	self.tablePosition = #coalitionSGLtable+1;

	coalitionSGLtable[self.tablePosition] = self;

--------------------------------------------------
---------- Variables

	self.wepname = "Mine Launcher"; -- PresetName of gun.

	self.firespeed = 35; -- Speed of projectile when fired.
	self.degreespread = 5; -- How much spread the projectile has when shot.
	self.sharpdegreespread = 1; -- How much spread the projectile has when shot while Sharp Aiming.

	self.ignoreparent = true; -- if the projectile should ignore the parent when trying to stick to something. true for yes, false for no.

--------------------------------------------------
---------- Gun/Parent Finding

	self.curdist = 10;
	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.ClassName == "HDFirearm" and gun.PresetName == self.wepname and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,self.mapwrapx).Magnitude <= self.curdist then
			self.parentgun = ToHDFirearm(gun);
			local actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(actor) == true then
				self.parent = ToActor(actor);
			end
		end
	end

--------------------------------------------------
---------- Projectile Velocity

	if self.parentgun ~= nil then
		if math.random(1,2) == 2 then
			self.negatore = -1;
		else
			self.negatore = 1;
		end

		if self.parent ~= nil and self.parent:GetController():IsState(Controller.AIM_SHARP) then
			self.Vel = Vector(self.firespeed,0):RadRotate(self.parent:GetAimAngle(true)):DegRotate(   (   (math.random(1,100)*self.negatore)   /   100)   *   (self.sharpdegreespread/2)   );
		else
			self.Vel = Vector(self.firespeed,0):RadRotate(self.parent:GetAimAngle(true)):DegRotate(   (   (math.random(1,100)*self.negatore)   /   100)   *   (self.degreespread/2)   );
		end

		self.negatore = nil;
	end

--------------------------------------------------

end

function Update(self)

--------------------------------------------------
---------- Sticky Stuff

	if self.ignoreparent == true then
		if MovableMan:IsActor(self.parent) == true then
			self.ignoreid = self.parent.ID;
		end
	else
		self.ignoreid = 255;
	end

	if self.stickmode == 0 then

		self.Sharpness = 255;

		self.stickobject = SceneMan:CastMORay(self.Pos,Vector(5,0):RadRotate(self.Vel.AbsRadAngle),self.ignoreid,0,false,0);
		self.clingpos = Vector(0,0);

		if self.stickobject ~= 255 and self.stickobject ~= self.ID then
			self.Sharpness = self.stickobject;
			self.sticktarget = MovableMan:GetMOFromID(self.stickobject);
			self.stickpositionX = self.Pos.X-self.sticktarget.Pos.X;
			self.stickpositionY = self.Pos.Y-self.sticktarget.Pos.Y;
			self.stickrotation = self.sticktarget.RotAngle;
			self.stickdirection = self.RotAngle;
			self.startflipped = self.sticktarget.HFlipped;
			self.stickmode = 1;
		elseif SceneMan:CastStrengthRay(self.Pos,Vector(12,0):RadRotate(self.Vel.AbsRadAngle),0,self.clingpos,0,0,self.mapwrapx) == true then
			self.Vel = Vector(0,0);
			self.PinStrength = 1000;
			self.Pos = self.clingpos + SceneMan:ShortestDistance(self.clingpos,self.Pos,self.mapwrapx):SetMagnitude(3);
			self.stickmode = 2;
		end

	elseif self.stickmode == 1 then

		if self.sticktarget ~= nil and self.sticktarget.ID ~= 255 then
			self.Sharpness = self.sticktarget.RootID;
			if self.Mass ~= self.startMass then
				self:GibThis();
				self.ToDelete = true;
				self.stickmode = 3;
			end
			self.ToDelete = false;
			self.ToSettle = false;
			self.Pos = self.sticktarget.Pos + Vector(self.stickpositionX,self.stickpositionY):RadRotate(self.sticktarget.RotAngle-self.stickrotation);
			self.RotAngle = self.stickdirection+(self.sticktarget.RotAngle-self.stickrotation);
			self.Vel = Vector(0,0);
			self.PinStrength = 1000;
		else
			self.PinStrength = 0;
			self.sticktarget = nil;
			self.stickmode = 0;
		end

	end

	if self.lifeTimer:IsPastSimMS(3000) or self.stickmode == 3 then
		for i = 1, #coalitionSGLtable do
			if MovableMan:IsParticle(coalitionSGLtable[i]) and coalitionSGLtable[i].Sharpness == self.Sharpness then
				coalitionSGLtable[i].Mass = 12;
			end
		end
		self:GibThis();
	end

end

function Destroy(self)

	coalitionSGLtable[self.tablePosition] = nil;

end

function Create(self)
--The timer that will measure out the missile's events.
    self.LTimer = Timer();

--The missile's target, currently set to nothing.

    self.target = nil;

--Find out who shot the weapon by finding the closest actor within 50 pixels.
    local curdist = 50;
    for actor in MovableMan.Actors do
	local avgx = actor.Pos.X - self.Pos.X;
	local avgy = actor.Pos.Y - self.Pos.Y;
	local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
	if dist < curdist then
	    curdist = dist;
	    self.parent = actor;
	end
    end

--If the missile has no firer, make it go after anyone.  Otherwise, set its team to that of the firer.
    if MovableMan:IsActor(self.parent) then
	self.Team = self.parent.Team;
    else
	self.Team = -1;
    end
end

function Update(self)
    if self.LTimer:IsPastSimMS(250) or MovableMan:IsActor(self.target) == false then
	--Get a target.  Go for the closest actor within 500 pixels.
	if MovableMan:IsActor(self.target) == false then
	    local curdist = 500;
	    for actor in MovableMan.Actors do
		local avgx = actor.Pos.X - self.Pos.X;
		local avgy = actor.Pos.Y - self.Pos.Y;
		local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
		if dist < curdist and actor.Team ~= self.Team then
		    curdist = dist;
		    self.target = actor;
		end
	    end
	end

	--If the target still exists...
	if MovableMan:IsActor(self.target) then

	    --Make sure the missile's thruster is firing.
	    if self:IsEmitting() == false then
	        self:EnableEmission(true);
	    end

	    local turnspeed = 0.5;
	    local maxspeed = 30;
	    
	    local targetdir = math.atan2(-(self.target.Pos.Y-self.Pos.Y),(self.target.Pos.X-self.Pos.X));
	    local desiredspeedx = math.cos(targetdir) * maxspeed
	    local desiredspeedy = math.sin(targetdir) * (-maxspeed)
	    
	    if self.Vel.X < desiredspeedx then
	    	self.Vel.X = self.Vel.X + turnspeed
	    elseif self.Vel.X > desiredspeedx then
	    	self.Vel.X = self.Vel.X - turnspeed
	    end
	    if self.Vel.Y < desiredspeedy then
	    	self.Vel.Y = self.Vel.Y + turnspeed
	    elseif self.Vel.Y > desiredspeedy then
	    	self.Vel.Y = self.Vel.Y - turnspeed
	    end
	    
	else
	    --If there's no target, shut off the thrusters.
	    if self:IsEmitting() == true then
	        self:EnableEmission(false);
	    end
	end

	if self.LTimer:IsPastSimMS(5000) then
	    --If the missile has run out of time, self destruct!
	    self:GibThis();
	end
    end
end